<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑企业邮箱' : '添加企业邮箱'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="邮箱名称" name="name">
        <a-input
          allow-clear
          placeholder="请输入邮箱名称"
          v-model:value="form.name"
        />
      </a-form-item>
      <a-form-item label="绑定域名" name="code">
        <a-input
          allow-clear
          placeholder="请输入域名标识"
          v-model:value="form.code"
        />
      </a-form-item>
<!--      <a-form-item label="邮箱型号" name="type">-->
<!--        <a-input-->
<!--          allow-clear-->
<!--          placeholder="请输入邮箱型号"-->
<!--          v-model:value="form.type"-->
<!--        />-->
<!--      </a-form-item>-->
<!--      <a-form-item label="品牌厂商" name="brand">-->
<!--        <a-input-->
<!--          allow-clear-->
<!--          placeholder="请输入品牌厂商"-->
<!--          v-model:value="form.brand"-->
<!--        />-->
<!--      </a-form-item>-->
      <a-form-item label="登录账号" name="system">
        <a-input
          allow-clear
          placeholder="请输入初始账号"
          v-model:value="form.system"
        />
      </a-form-item>
      <a-form-item label="价格" name="price">
        <a-input
          allow-clear
          placeholder="请输入价格"
          v-model:value="form.price"
        />
      </a-form-item>
<!--      <a-form-item label="详情内容" name="content">-->
<!--        <a-input-->
<!--          allow-clear-->
<!--          placeholder="请输入详情内容"-->
<!--          v-model:value="form.content"-->
<!--        />-->
<!--      </a-form-item>-->
      <a-form-item label="购买时间" name="startTime">
        <a-input
          allow-clear
          placeholder="请输入购买时间"
          v-model:value="form.startTime"
        />
      </a-form-item>
      <a-form-item label="到期时间" name="endTime">
        <a-input
          allow-clear
          placeholder="请输入到期时间"
          v-model:value="form.endTime"
        />
      </a-form-item>
      <a-form-item label="排序" name="sortNumber">
        <a-input-number
          :min="0"
          :max="9999"
          class="ele-fluid"
          placeholder="请输入排序号"
          v-model:value="form.sortNumber"
        />
      </a-form-item>
      <a-form-item label="描述" name="comments">
        <a-textarea
          :rows="4"
          :maxlength="200"
          placeholder="请输入描述"
          v-model:value="form.comments"
        />
      </a-form-item>
<!--      <a-form-item label="状态" name="status">-->
<!--        <a-radio-group v-model:value="form.status">-->
<!--          <a-radio :value="0">显示</a-radio>-->
<!--          <a-radio :value="1">隐藏</a-radio>-->
<!--        </a-radio-group>-->
<!--      </a-form-item>-->
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addOaAssetsEmail, updateOaAssetsEmail } from '@/api/oa/oaAssetsEmail';
  import { OaAssetsEmail } from '@/api/oa/oaAssetsEmail/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: OaAssetsEmail | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<OaAssetsEmail>({
    emailId: undefined,
    name: undefined,
    code: undefined,
    type: undefined,
    brand: undefined,
    system: undefined,
    price: undefined,
    content: undefined,
    startTime: undefined,
    endTime: undefined,
    isTop: undefined,
    comments: undefined,
    userId: undefined,
    userIds: undefined,
    status: undefined,
    deleted: undefined,
    tenantId: undefined,
    createTime: undefined,
    updateTime: undefined,
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    oaAssetsEmailName: [
      {
        required: true,
        type: 'string',
        message: '请填写企业邮箱记录表名称',
        trigger: 'blur'
      }
    ]
  });

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateOaAssetsEmail : addOaAssetsEmail;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
